create or replace
PROCEDURE IMPORTA_CLIENTE_CHQ
IS
   /* CLIENTE */
   V_CDCLIENTE   VARCHAR2(20);
   V_NMRAZAOSOC  VARCHAR2(40);
   V_NMFANTCLIE  VARCHAR2(40);
   V_DSENDERECO  VARCHAR2(40);
   V_CDPAIS      VARCHAR2(4);
   V_SGESTADO    VARCHAR2(2);
   V_CDMUNICIPIO VARCHAR2(7);
   V_CDCEP       VARCHAR2(15);
   V_NMBAIRRO    VARCHAR2(30);
   V_EMAIL       VARCHAR2(40);
   V_IDINTERFACE INTEGER;
   V_TPINTERFACE VARCHAR2(1);
   V_CDPAISP     VARCHAR2(4);
   V_SGESTADOP   VARCHAR2(2);
   V_CDMUNICIP   VARCHAR2(7);
   V_CLIENTE     VARCHAR2(21);
   V_VALIDA      VARCHAR2(15);
   V_TPIJURCLIE  VARCHAR2(1);
   V_CDCLIENTEUN VARCHAR2(30);
   V_NRINSJURCLI VARCHAR2(21);
   /* INTECLIE */
   V_NMINTECLIE  VARCHAR2(50);
   V_DSENDEINTE  VARCHAR2(40);
   V_CDPAISINTE  VARCHAR2(4);
   V_SGESTINTE   VARCHAR2(2);
   V_CDMUNIINTE  VARCHAR2(7);
   V_CDCEPINTE   VARCHAR2(15);
   V_NMBAIINTE   VARCHAR2(30);
   V_EMAILINTE   VARCHAR2(40);
   V_IDTPINTECLI VARCHAR2(1);
   V_IDINTERINTE INTEGER;
   V_TPINTERINTE VARCHAR2(1);
   V_CDINTECLIE  INTEGER;
   V_CDPAISINTEV VARCHAR2(4);
   V_SGESTINTEV  VARCHAR2(2);
   V_CDMUNIINTEV VARCHAR2(7);
   /* LOG */
   V_IDSEQLOG    INTEGER;
   V_MENSERRO    VARCHAR2(250);

   CURSOR C_CLIENTE IS
      SELECT U.CDCLIENTE, U.NMRAZAOSOC, U.NMFANTCLIE, U.DSENDERECOP, P.CDPAIS,
             E.SGESTADO, M.CDMUNICIPIO, U.CDCEPP, U.NMBAIRROP, U.EMAIL,
             U.IDINTERFACE, U.TPINTERFACE, U.CDPAISP, U.SGESTADOP, U.CDMUNICIPIOP,
             U.CDCLIENTEUN
        FROM USR_CHQ_CLIENTE U LEFT OUTER JOIN PAIS P
                                            ON U.CDPAISP   = P.CDPAIS
                               LEFT OUTER JOIN ESTADO E
                                            ON U.CDPAISP   = E.CDPAIS
                                           AND U.SGESTADOP = E.SGESTADO
                               LEFT OUTER JOIN MUNICIPIO M
                                            ON U.CDPAISP   = M.CDPAIS
                                           AND U.SGESTADOP = M.SGESTADO
                                           AND U.CDMUNICIPIOP = M.CDMUNICIBGE
       WHERE U.STATUS = 1;
   
   CURSOR C_INTECLIE(V_CDCLIENTE IN VARCHAR2) IS
      SELECT U.NMINTECLIE, U.DSENDERECOP, P.CDPAIS, E.SGESTADO, M.CDMUNICIPIO, U.CDCEPP,
             U.NMBAIRROP, U.EMAIL, U.IDTPINTECLIE, U.IDINTERFACE, U.TPINTERFACE,
             U.CDPAISP, U.SGESTADOP, U.CDMUNICIPIOP
        FROM USR_CHQ_INTECLIE U LEFT OUTER JOIN PAIS P
                                             ON U.CDPAISP   = P.CDPAIS
                                LEFT OUTER JOIN ESTADO E
                                             ON U.CDPAISP   = E.CDPAIS
                                            AND U.SGESTADOP = E.SGESTADO
                                LEFT OUTER JOIN MUNICIPIO M
                                             ON U.CDPAISP   = M.CDPAIS
                                            AND U.SGESTADOP = M.SGESTADO
                                            AND U.CDMUNICIPIOP = M.CDMUNICIBGE
       WHERE U.CDCLIENTE = V_CDCLIENTE
         AND U.STATUS = 1;
   
   FUNCTION DIGITO_VERIF(P_VALOR IN INTEGER) RETURN INTEGER
   IS
      VALOR INTEGER;
   BEGIN
      VALOR := MOD(P_VALOR,11);
      IF VALOR < 2 THEN
         VALOR := 0;
      ELSE
         VALOR := 11-VALOR;
      END IF;
      
      RETURN VALOR;
   END;
   
   PROCEDURE VALIDA_INSC(P_INSCRICAO IN VARCHAR2, P_TIPOINSC IN VARCHAR2, P_DIGVERIF OUT VARCHAR2)
   IS
      DIGVERIF VARCHAR2(15);
      CALC INTEGER;
      DIGITO INTEGER;
      TYPE VET_CNPJ IS VARRAY(13) OF INTEGER;
      VETOR VET_CNPJ;
      BOPRIMEIRO BOOLEAN;
   BEGIN   
      DIGITO := 0;
      
      IF P_TIPOINSC = 'F' THEN
         SELECT REVERSE(P_INSCRICAO)
           INTO DIGVERIF
           FROM DUAL;
         
         FOR I IN 1..LENGTH(DIGVERIF)
         LOOP
            CALC := TO_NUMBER(SUBSTR(DIGVERIF,I,1))*(I+1);
            DIGITO := DIGITO + CALC;
         END LOOP;
         
         DIGITO := DIGITO_VERIF(DIGITO);
         
         DIGVERIF := DIGITO||DIGVERIF;
         SELECT REVERSE(DIGVERIF)
           INTO DIGVERIF
           FROM DUAL;
         
         IF LENGTH(DIGVERIF) < 11 THEN
            VALIDA_INSC(DIGVERIF, P_TIPOINSC, P_DIGVERIF);
         ELSE
            P_DIGVERIF := DIGVERIF;
         END IF;
      ELSE
         DIGVERIF := P_INSCRICAO;
         IF LENGTH(DIGVERIF) = 12 THEN
            VETOR := VET_CNPJ(5,4,3,2,9,8,7,6,5,4,3,2);
            BOPRIMEIRO := TRUE;
         ELSE
            VETOR := VET_CNPJ(6,5,4,3,2,9,8,7,6,5,4,3,2);
            BOPRIMEIRO := FALSE;
         END IF;
         
         FOR I IN 1..LENGTH(DIGVERIF)
         LOOP
            CALC := TO_NUMBER(SUBSTR(DIGVERIF,I,1))*VETOR(I);
            DIGITO := DIGITO + CALC;
         END LOOP;
         
         DIGITO := DIGITO_VERIF(DIGITO);
         DIGVERIF := DIGVERIF||DIGITO;
         
         IF BOPRIMEIRO THEN
            VALIDA_INSC(DIGVERIF, P_TIPOINSC, P_DIGVERIF);
         ELSE
            P_DIGVERIF := DIGVERIF;
         END IF;         
      END IF;
   END;    
       
BEGIN
   OPEN C_CLIENTE;
   LOOP
      FETCH C_CLIENTE INTO V_CDCLIENTE, V_NMRAZAOSOC, V_NMFANTCLIE, V_DSENDERECO, V_CDPAIS,
                           V_SGESTADO, V_CDMUNICIPIO, V_CDCEP, V_NMBAIRRO, V_EMAIL,
                           V_IDINTERFACE, V_TPINTERFACE, V_CDPAISP, V_SGESTADOP, V_CDMUNICIP,
                           V_CDCLIENTEUN;
      EXIT WHEN C_CLIENTE%NOTFOUND;
      
      V_CDCLIENTE := REGEXP_REPLACE(V_CDCLIENTE, '\D');
      V_VALIDA := '';
      V_CDINTECLIE := 0;
      SELECT USR_CHQ_IDSEQLOG.NEXTVAL
        INTO V_IDSEQLOG
        FROM DUAL;
      BEGIN
         SELECT MAX(CDCLIENTE) AS CLIENTE
           INTO V_CLIENTE
           FROM CLIENTE
          WHERE REGEXP_LIKE(NRINSJURCLIE, '(^0*0|^)'||V_CDCLIENTE||'$');
      EXCEPTION
         WHEN OTHERS THEN
            V_CLIENTE := NULL;
      END;
      
      IF (V_TPINTERFACE <> 'E') THEN
         IF (V_CDPAIS IS NOT NULL) THEN
            IF (V_SGESTADO IS NOT NULL) THEN
               IF (V_CDMUNICIPIO IS NOT NULL) THEN
                  IF (V_TPINTERFACE = 'I') THEN
                     IF (V_CLIENTE IS NULL) THEN
                        CASE
                           WHEN LENGTH(V_CDCLIENTE)<= 5  THEN V_TPIJURCLIE := 'O';
                           WHEN LENGTH(V_CDCLIENTE) = 11 THEN V_TPIJURCLIE := 'F';
                           WHEN LENGTH(V_CDCLIENTE) = 14 THEN V_TPIJURCLIE := 'J';
                           ELSE V_TPIJURCLIE := 'I';
                        END CASE;
                        
                        BEGIN
                           IF (V_TPIJURCLIE = 'F') OR (V_TPIJURCLIE = 'J') THEN
                              VALIDA_INSC(SUBSTR(V_CDCLIENTE,1,LENGTH(V_CDCLIENTE)-2), V_TPIJURCLIE, V_VALIDA);
                           END IF;   
                           
                           IF (V_VALIDA = V_CDCLIENTE) THEN
                              V_CLIENTE := V_TPIJURCLIE||V_CDCLIENTE;
                              V_NRINSJURCLI := V_CDCLIENTE;
                           ELSE
                              /* CASO O DIGITO DO CPF/CNPJ SEJA INVALIDO OU A INSCRICAO POSSUA QUANTIDADE DE CARACTERES DIFERENTES
                                 DOS CITADOS, O CLIENTE SERA INCLUIDO COM A INSCRICAO 'I' (SE MAIOR QUE 5 CARACTERS) OU 'O', 
                                 COMPLETANDO ASSIM COM 0 (ZEROS) A ESQUERDA SE NECESSARIO */
                              IF (LENGTH(V_CDCLIENTE)>5) THEN
                                 V_TPIJURCLIE := 'I';
                                 V_NRINSJURCLI  := LPAD(V_CDCLIENTE,20,'0');
                                 V_CLIENTE := V_TPIJURCLIE||V_NRINSJURCLI;
                              ELSE
                                 V_NRINSJURCLI := LPAD(V_CDCLIENTE,5,'0');
                                 V_CLIENTE := V_TPIJURCLIE||V_NRINSJURCLI;
                              END IF;
                           END IF;
                           
                           INSERT INTO CLIENTE(CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE, IDCLIEATIV, CDEXCLIENTE)
                           VALUES(V_CLIENTE, V_TPIJURCLIE, V_NRINSJURCLI, V_NMRAZAOSOC, V_NMFANTCLIE, 'S', V_CDCLIENTEUN);
                           
                           INSERT INTO ENDECLIE(CDCLIENTE, DSENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, IDTPENDECLIE)
                           VALUES(V_CLIENTE, V_DSENDERECO, V_CDPAIS, V_SGESTADO, V_CDMUNICIPIO, 'P');
                           
                           UPDATE USR_CHQ_CLIENTE
                              SET STATUS = 0
                            WHERE IDINTERFACE = V_IDINTERFACE;
                           
                           INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 0, 'Cliente inserido com sucesso');
                           
                           OPEN C_INTECLIE(V_CDCLIENTE);
                           LOOP
                              FETCH C_INTECLIE INTO V_NMINTECLIE, V_DSENDEINTE, V_CDPAISINTE, V_SGESTINTE, V_CDMUNIINTE, V_CDCEPINTE,
                                                    V_NMBAIINTE, V_EMAILINTE, V_IDTPINTECLI, V_IDINTERINTE, V_TPINTERINTE,
                                                    V_CDPAISINTEV, V_SGESTINTEV, V_CDMUNIINTEV;
                              EXIT WHEN C_INTECLIE%NOTFOUND;
                              
                              SELECT USR_CHQ_IDSEQLOG.NEXTVAL
                                INTO V_IDSEQLOG
                                FROM DUAL;
                              
                              IF (V_CDPAISINTE IS NOT NULL) THEN
                                 IF (V_SGESTINTE IS NOT NULL) THEN
                                    IF (V_CDMUNIINTE IS NOT NULL) THEN
                                       BEGIN
                                          INSERT INTO INTECLIE(CDCLIENTE, CDINTECLIE, NMINTECLIE, IDTPINTECLIE, 
                                                               CDPAIS, SGESTADO, CDMUNICIPIO, DSENDEINCLIE, NRCEPINCLIE,
                                                               NMBAIRINCLIE, DSEMAILICLIE)
                                          VALUES(V_CLIENTE, TO_CHAR(LPAD(V_CDINTECLIE,2,'0')), V_NMINTECLIE, V_IDTPINTECLI,
                                                 V_CDPAISINTE, V_SGESTINTE, V_CDMUNIINTE, V_DSENDEINTE, V_CDCEPINTE,
                                                 V_NMBAIINTE, V_EMAILINTE);
                                          
                                          UPDATE USR_CHQ_INTECLIE
                                             SET STATUS = 0
                                           WHERE IDINTERFACE = V_IDINTERINTE;
                                          
                                          INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                          VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 0, 'Interlocutor inserido com sucesso para o cliente c'||CHR(243)||'digo '||V_CDCLIENTE);
                                          
                                          V_CDINTECLIE := V_CDINTECLIE+1;
                                       EXCEPTION
                                          WHEN OTHERS THEN
                                             V_MENSERRO := SQLERRM(SQLCODE);
                                             
                                             UPDATE USR_CHQ_INTECLIE
                                                SET STATUS = 2
                                              WHERE IDINTERFACE = V_IDINTERINTE;
                                             
                                             INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                             VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'Erro ao incluir o interlocutor do cliente '||V_CDCLIENTE||'. Erro: '||V_MENSERRO);
                                       END;
                                    ELSE
                                       UPDATE USR_CHQ_INTECLIE
                                          SET STATUS = 2
                                        WHERE IDINTERFACE = V_IDINTERINTE;
                                       
                                       INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                       VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' munic'||CHR(237)||'pio com o c'||CHR(243)||'digo IBGE '||V_CDMUNIINTEV||' cadastrado no sistema. Incluso de interlocutor');
                                    END IF;
                                 ELSE
                                    UPDATE USR_CHQ_INTECLIE
                                       SET STATUS = 2
                                     WHERE IDINTERFACE = V_IDINTERINTE;
                                    
                                    INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                    VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' estado com a sigla '||V_SGESTINTEV||' cadastrado no sistema. Incluso de interlocutor');
                                 END IF;
                              ELSE
                                 UPDATE USR_CHQ_INTECLIE
                                    SET STATUS = 2
                                  WHERE IDINTERFACE = V_IDINTERINTE;
                                 
                                 INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                 VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' pa'||CHR(237)||'s com o c'||CHR(243)||'digo '||V_CDPAISINTEV||' cadastrado no sistema. Incluso de interlocutor');
                              END IF;
                           END LOOP;
                           
                           CLOSE C_INTECLIE;
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := SQLERRM(SQLCODE);
                              UPDATE USR_CHQ_CLIENTE
                                 SET STATUS = 2
                               WHERE IDINTERFACE = V_IDINTERFACE;
                              
                              INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                              VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'Erro ao incluir o cliente '||V_CDCLIENTE||': '||V_MENSERRO);
                        END;
                     ELSE
                        UPDATE USR_CHQ_CLIENTE
                           SET STATUS = 2
                         WHERE IDINTERFACE = V_IDINTERFACE;
                        
                        INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'Cliente j'||CHR(225)||' cadastrado');
                     END IF;
                  ELSE
                     IF (V_CLIENTE IS NOT NULL) THEN
                        BEGIN
                           UPDATE CLIENTE
                              SET NMRAZSOCCLIE = V_NMRAZAOSOC,
                                  NMFANTCLIE   = V_NMFANTCLIE,
                                  CDEXCLIENTE  = V_CDCLIENTEUN
                            WHERE CDCLIENTE = V_CLIENTE;
                           
                            UPDATE ENDECLIE
                               SET DSENDECLIE  = V_DSENDERECO,
                                   CDPAIS      = V_CDPAIS,
                                   SGESTADO    = V_SGESTADO,
                                   CDMUNICIPIO = V_CDMUNICIPIO,
                                   NRCEPCLIE   = V_CDCEP,
                                   NMBAIRCLIE  = V_NMBAIRRO,
                                   DSEMAILCLIE = V_EMAIL
                            WHERE CDCLIENTE = V_CLIENTE;
                            
                           UPDATE USR_CHQ_CLIENTE
                              SET STATUS = 0
                            WHERE IDINTERFACE = V_IDINTERFACE;
                           
                           INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 0, 'Cliente atualizado com sucesso');
                           
                           OPEN C_INTECLIE(V_CDCLIENTE);
                           LOOP
                              FETCH C_INTECLIE INTO V_NMINTECLIE, V_DSENDEINTE, V_CDPAISINTE, V_SGESTINTE, V_CDMUNIINTE, V_CDCEPINTE,
                                                    V_NMBAIINTE, V_EMAILINTE, V_IDTPINTECLI, V_IDINTERINTE, V_TPINTERINTE,
                                                    V_CDPAISINTEV, V_SGESTINTEV, V_CDMUNIINTEV;
                              EXIT WHEN C_INTECLIE%NOTFOUND;
                              
                              SELECT USR_CHQ_IDSEQLOG.NEXTVAL
                                INTO V_IDSEQLOG
                                FROM DUAL;
                              
                              IF (V_CDPAISINTE IS NOT NULL) THEN
                                 IF (V_SGESTINTE IS NOT NULL) THEN
                                    IF (V_CDMUNIINTE IS NOT NULL) THEN
                                       BEGIN
                                          INSERT INTO INTECLIE(CDCLIENTE, CDINTECLIE, NMINTECLIE, IDTPINTECLIE, 
                                                               CDPAIS, SGESTADO, CDMUNICIPIO, DSENDEINCLIE, NRCEPINCLIE,
                                                               NMBAIRINCLIE, DSEMAILICLIE)
                                          VALUES(V_CLIENTE, TO_CHAR(LPAD(V_CDINTECLIE,2,'0')), V_NMINTECLIE, V_IDTPINTECLI,
                                                 V_CDPAISINTE, V_SGESTINTE, V_CDMUNIINTE, V_DSENDEINTE, V_CDCEPINTE,
                                                 V_NMBAIINTE, V_EMAILINTE);
                                          
                                          UPDATE USR_CHQ_INTECLIE
                                             SET STATUS = 0
                                           WHERE IDINTERFACE = V_IDINTERINTE;
                                          
                                          INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                          VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 0, 'Interlocutor inserido com sucesso para o cliente c'||CHR(243)||'digo '||V_CDCLIENTE);
                                       EXCEPTION
                                          WHEN OTHERS THEN
                                             V_MENSERRO := SQLERRM(SQLCODE);
                                             
                                             UPDATE USR_CHQ_INTECLIE
                                                SET STATUS = 2
                                              WHERE IDINTERFACE = V_IDINTERINTE;
                                             
                                             INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                             VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'Erro ao incluir o interlocutor do cliente '||V_CDCLIENTE||': '||V_MENSERRO);
                                       END;
                                    ELSE
                                       UPDATE USR_CHQ_INTECLIE
                                          SET STATUS = 2
                                        WHERE IDINTERFACE = V_IDINTERINTE;
                                       
                                       INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                       VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' munic'||CHR(237)||'pio com o c'||CHR(243)||'digo IBGE '||V_CDMUNIINTEV||' cadastrado no sistema. Incluso de interlocutor');
                                    END IF;
                                 ELSE
                                    UPDATE USR_CHQ_INTECLIE
                                       SET STATUS = 2
                                     WHERE IDINTERFACE = V_IDINTERINTE;
                                    
                                    INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                    VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' estado com a sigla '||V_SGESTINTEV||' cadastrado no sistema. Incluso de interlocutor');
                                 END IF;
                              ELSE
                                 UPDATE USR_CHQ_INTECLIE
                                    SET STATUS = 2
                                  WHERE IDINTERFACE = V_IDINTERINTE;
                                 
                                 INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                 VALUES(V_IDINTERINTE, V_IDSEQLOG, 3, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' pa'||CHR(237)||'s com o c'||CHR(243)||'digo '||V_CDPAISINTEV||' cadastrado no sistema. Incluso de interlocutor');
                              END IF;
                           END LOOP;
                           
                           CLOSE C_INTECLIE;
                           
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := SQLERRM(SQLCODE);
                              UPDATE USR_CHQ_CLIENTE
                                 SET STATUS = 2
                               WHERE IDINTERFACE = V_IDINTERFACE;
                              
                              INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                              VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'Erro ao atualizar o cliente '||V_CDCLIENTE||': '||V_MENSERRO);
                        END;
                     ELSE
                        UPDATE USR_CHQ_CLIENTE
                           SET STATUS = 2
                         WHERE IDINTERFACE = V_IDINTERFACE;
                        
                        INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' cliente com o c'||CHR(243)||'digo '||V_CLIENTE||' cadastrado no sistema');
                     END IF;
                  END IF;
               ELSE
                  UPDATE USR_CHQ_CLIENTE
                     SET STATUS = 2
                   WHERE IDINTERFACE = V_IDINTERFACE;
                  
                  INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' munic'||CHR(237)||'pio com o c'||CHR(243)||'digo IBGE '||V_CDMUNICIP||' cadastrado no sistema');
               END IF;
            ELSE
               UPDATE USR_CHQ_CLIENTE
                  SET STATUS = 2
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' estado com a sigla '||V_SGESTADOP||' cadastrado no sistema');
            END IF;
         ELSE
            UPDATE USR_CHQ_CLIENTE
               SET STATUS = 2
             WHERE IDINTERFACE = V_IDINTERFACE;
            
            INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' pa'||CHR(237)||'s com o c'||CHR(243)||'digo '||V_CDPAISP||' cadastrado no sistema');
         END IF;
      ELSE
         BEGIN
            DELETE FROM CLIENTE CASCADE
             WHERE CDCLIENTE = V_CLIENTE;
            
            IF SQL%ROWCOUNT > 0 THEN
               UPDATE USR_CHQ_CLIENTE
                  SET STATUS = 0
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 0, 'Cliente apagado com sucesso');
            ELSE
               UPDATE USR_CHQ_CLIENTE
                  SET STATUS = 2
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' cliente cadastrado com o c'||CHR(243)||'digo '||V_CDCLIENTE);
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
               V_MENSERRO := SQLERRM(SQLCODE);
               UPDATE USR_CHQ_CLIENTE
                  SET STATUS = 2
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'Erro ao excluir o cliente '||V_CDCLIENTE||': '||V_MENSERRO);
         END;
      END IF;
   END LOOP;
   
   CLOSE C_CLIENTE;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      V_MENSERRO := SQLERRM(SQLCODE);
      UPDATE USR_CHQ_CLIENTE
         SET STATUS = 2
       WHERE IDINTERFACE = V_IDINTERFACE;
      
      INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
      VALUES(V_IDINTERFACE, V_IDSEQLOG, 2, SYSDATE, 1, 'Erro na importao do cliente '||V_CDCLIENTE||': '||V_MENSERRO);
      
      CLOSE C_INTECLIE;      
      CLOSE C_CLIENTE;
   
      COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_CLIENTE_CHQ','6.05.XXX'); END;
/